Attribute VB_Name = "modGeneral"
Option Explicit

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Public Declare Function GetTickCount Lib "kernel32.dll" () As Long
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Public Cfg As New clsConfig
Public Pkt As New clsPacket
Public Reg As New clsRegistryAccess
Public Acc() As String
Public Hash As tHash
Public Counter As Integer

Public OnlineTick As Long
Public ReconnectTick As Long

Public Type tHash
    KeyDecoder As Long
    HashLength As Long
    KeyHash As String
    Account As String
    Password As String
    NLS As Long
    NLSversion As Long
    ClientKey As Long
    ServerKey As Long
    MPQFile As String
    MPQFileTime As String
    mpqNumber As Long
    ChecksumFormula As String
End Type

Public Sub AddChat(ParamArray saElements() As Variant)
    Dim i As Integer

    For i = LBound(saElements) To UBound(saElements) Step 2
        With frmMain.rtbChat
            .SelStart = Len(.Text)
            .SelLength = 0
            .SelColor = saElements(i)
            .SelText = saElements(i + 1) & Left$(vbCrLf, -2 * CLng((i + 1) = UBound(saElements)))
            .SelStart = Len(.Text)
        End With
    Next i
End Sub

Public Function IsLastAccount() As Boolean
    If Counter >= UBound(Acc()) Then
        IsLastAccount = True
    End If
End Function

Public Function NextAccount(ByRef Account As String, ByRef Password As String) As Boolean
    Counter = Counter + 1
    If Counter > UBound(Acc()) Then
        Exit Function
    End If
    
    Account = Split(Acc(Counter), " ")(0)
    Password = Split(Acc(Counter), " ")(1)
    NextAccount = True
End Function

Public Sub LoadAccounts()
    ReDim Acc(0)
    Counter = 0
    Dim strLine As String
    
    On Error GoTo CloseFile:
    Open App.Path & "\Accounts.txt" For Input As #1
        Do Until EOF(1)
        Line Input #1, strLine
            If InStr(strLine, " ") > 0 Then
                If Len(Split(strLine, " ")(0)) > 0 And Len(Split(strLine, " ")(1)) > 0 Then
                    ReDim Preserve Acc(UBound(Acc) + 1)
                    Acc(UBound(Acc)) = strLine
                End If
            End If
        Loop
    Close #1
    Exit Sub
CloseFile:
    Close #1
    MsgBox "Unable to load accounts, please enter accounts before beginning the revive cycle.", vbExclamation
End Sub

Public Sub SaveAccounts()
    On Error GoTo CloseFile:
    Dim strLine As String
    
    Open App.Path & "\Accounts.txt" For Append As #1
    Close #1
    
    Open App.Path & "\Accounts.txt" For Output As #1
        Dim i As Integer
        For i = 0 To UBound(Acc())
            If Len(Acc(i)) > 0 Then
                Print #1, Acc(i)
            End If
        Next i
    Close #1
    Exit Sub
CloseFile:
    Close #1
    MsgBox "You have to load some accounts before you can save them!", vbExclamation
End Sub

